`timescale 1ns / 1ps
module fast_power(
  input CLK, RESET, START,
  input [7:0] BASE, EXP,
  output DONE,
  output [511:0] POW
);

  wire EXP_ZERO_N, EXP_BIT, LOADPOW, MULPOW;
  wire LOADPOW2N, LOADEXP, RDONE, SDONE;

  // Instanziere Steuerwerk
  fast_power_fsm FAST_POWER_FSM (
    .CLK(CLK), 
    .RESET(RESET), 
    .START(START), 
    .EXP_ZERO_N(EXP_ZERO_N), 
    .EXP_BIT(EXP_BIT), 
    .LOADPOW(LOADPOW), 
    .MULPOW(MULPOW), 
    .LOADPOW2N(LOADPOW2N), 
    .LOADEXP(LOADEXP), 
    .RDONE(RDONE), 
    .SDONE(SDONE)
  );

  // Instanziere Datenpfad
  fast_power_dp FAST_POWER_DP (
    .CLK(CLK), 
    .RESET(RESET), 
    .LOADPOW(LOADPOW), 
    .MULPOW(MULPOW), 
    .LOADPOW2N(LOADPOW2N), 
    .LOADEXP(LOADEXP), 
    .RDONE(RDONE), 
    .SDONE(SDONE), 
    .EXP(EXP), 
    .BASE(BASE), 
    .EXP_ZERO_N(EXP_ZERO_N), 
    .EXP_BIT(EXP_BIT), 
    .DONE(DONE), 
    .POW(POW)
  );

endmodule
