`timescale 1ns / 1ps
module tb_fast_power_v;

  // Inputs
  reg CLK;
  reg RESET;
  reg START;
  reg [7:0] BASE;
  reg [7:0] EXP;

  // Outputs
  wire DONE;
  wire [511:0] POW;

  // Instantiate the Unit Under Test (UUT)
  fast_power uut (
    .CLK(CLK), 
    .RESET(RESET), 
    .START(START), 
    .BASE(BASE), 
    .EXP(EXP), 
    .DONE(DONE), 
    .POW(POW)
  );

  // Erzeuge einen Taktzyklus
  task DoClockCycle;
    begin
      #5;
      CLK = 1;
      #5;
      CLK = 0;
    end
  endtask

  // Testdaten-Ausgabe
  initial
    $monitor("Zeit: %t   START=%b DONE=%b BASE=%d EXP=%d POW=%0d",
             $time, START, DONE, BASE, EXP, POW);

  initial begin
    // Reset der Schaltung
    RESET = 1;
    DoClockCycle;
    RESET = 0;
    DoClockCycle;
    // Berechne 2 hoch 0
    BASE = 2; EXP = 0;
    START = 1;
    DoClockCycle;
    START = 0;
    DoClockCycle;
    while (!DONE)
      DoClockCycle;
    // Berechne 2 hoch 31
    EXP = 31;
    START = 1;
    DoClockCycle;
    START = 0;
    DoClockCycle;
    while (!DONE)
      DoClockCycle;
    // Berechne 42 hoch 42
    BASE = 42; EXP = 42;
    START = 1;
    DoClockCycle;
    START = 0;
    DoClockCycle;
    while (!DONE)
      DoClockCycle;
  end
      
endmodule
